unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, IdBaseComponent,
  IdComponent, IdUDPBase, IdUDPServer, IdGlobal, IdSocketHandle, IdUDPClient;

type
  TfrmUDPTest = class(TForm)
    lLastTrade: TLabel;
    Label2: TLabel;
    lPrice: TLabel;
    ComboBox1: TComboBox;
    IdUDPServer1: TIdUDPServer;
    lLastCandle: TLabel;
    procedure IdUDPServer1UDPRead(AThread: TIdUDPListenerThread;
      const AData: TIdBytes; ABinding: TIdSocketHandle);
    procedure ComboBox1Change(Sender: TObject);
  private
    SelectedCoin:  string;
    { Private declarations }
  public
    { Public declarations }
  end;

  TOrderType = (O_SELL,O_BUY,O_BuyStop);

  TUpdateKind = (UK_Candles, UK_Trades);

  TUpdateHeader = packed record
    Version:          byte;         // packet version, currently 1
    TimeStamp:        dword;        // Unix timestamp
    Kind:             TUpdateKind;  // candles or trades inside
    Coin:             string[7];    // coin ticker name
    Count:            word;         // elements count in the data array
    reserved1:        dword;
    reserved2:        dword;
  end;

  TTradeOrder = record
    ID:                       integer;
    Time:                     TDateTime;
    Price:                    double;
    Quantity:                 double;
    BuyerID:                  integer;
    reserved:                 integer;
    OrderType:                TOrderType;
    FillType:                 byte; // 0 - PARTIAL, 1 - FULL
  end;

  TCandle = record
    OpenP,CloseP,MaxP,MinP:   double;
    Vol:                      double;
    Time:                     TDateTime;
  end;

  TTrades = array of TTradeOrder;
  TCandles = array of TCandle;



var
  frmUDPTest: TfrmUDPTest;

implementation

{$R *.dfm}

procedure TfrmUDPTest.ComboBox1Change(Sender: TObject);
begin
  SelectedCoin:=ComboBox1.Text;
end;

procedure TfrmUDPTest.IdUDPServer1UDPRead(AThread: TIdUDPListenerThread;
  const AData: TIdBytes; ABinding: TIdSocketHandle);
var
  hdr:        TUpdateHeader;
  Trades:     TTrades;
  Candles:    TCandles;
  s:          string;
  LastTrade:  TTradeOrder;
begin
  move(AData[0], hdr, SizeOf(hdr));
  If ComboBox1.Items.IndexOf(hdr.Coin) < 0
    then ComboBox1.Items.Add(hdr.Coin);
  If hdr.Kind = UK_Trades then begin
    SetLength(Trades, hdr.Count);
    move(AData[SizeOf(hdr)], Trades[0], hdr.Count * SizeOf(TTradeOrder));
    If SelectedCoin = hdr.Coin
      then lPrice.Caption:=hdr.Coin + ' Last: ' + FloatToStr(Trades[hdr.Count - 1].Price);
  end;

  If hdr.Kind = UK_Candles then begin
    SetLength(Candles, hdr.Count);
    move(AData[SizeOf(hdr)], Candles[0], hdr.Count * SizeOf(TCandle));
    lLastCandle.Caption:=' Last candle: ' + hdr.Coin + ' 5m vol: ' + FloatToStr(Candles[hdr.Count - 1].Vol);
  end;

  lLastTrade.Caption:=Format('Last update: %s  time: %d', [hdr.Coin, hdr.TimeStamp]);
end;

end.
